
#ifndef _TEST_HELPER
#define _TEST_HELPER

#include <string>
#include <iterator>

//===========================================================================
// Integer

class Integer
{
public:
	Integer() : _i( 0 ) {}
	Integer( int i ) : _i( i ) {}
	const Integer operator=( const Integer& other )
	{
		_i = other._i;
		return(*this);
	}
	bool operator==( const Integer& other ) const
	{
		return _i == other._i;
	}
	int getTheInteger() const { return _i; }
	friend std::ostream& operator<<(std::ostream& os, const Integer& i);
private:
	int _i;
};

std::ostream& operator<<(std::ostream& os, const Integer& i)
{
	os << i.getTheInteger();
	return os;
}

//===========================================================================
// String

class String
{
public:
	String() : _s( "" ) {}
	String( std::string s ) : _s( s ) {}
	const String operator=( const String& other )
	{
		_s = other._s;
		return(*this);
	}
	bool operator==( const String& other ) const
	{
		return _s == other._s;
	}
	std::string getTheString() const { return _s; }
	friend std::ostream& operator<<(std::ostream& os, const String& s);
private:
	std::string _s;
};

std::ostream& operator<<(std::ostream& os, const String& s)
{
	os << s.getTheString();
	return os;
}

//===========================================================================
// Varie

template <typename T>
void print_vector( std::vector<T> v )
{
    using namespace std;
	ostream_iterator<T> out( cout, " " );
	cout << "Vector: ";
	copy( v.begin(), v.end(), out );
	cout << endl;
}


#endif